<?php
/**
* @author      Opensource Design, http://www.opensourcedesign.nl
* @copyright   Copyright (C) 2015 Opensource Design. All rights reserved.
* @license     GNU General Public License, http://www.gnu.org/copyleft/gpl.html
* @Version     1.0.0
**/

// no direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

class plgSystemF2cMetadataInjector extends JPlugin
{
	public function onBeforeRender()
	{
		if(!class_exists('F2cFactory')) require_once(JPATH_SITE.'/components/com_form2content/factory.form2content.php');
		if(!class_exists('Path')) require_once(JPATH_SITE.'/components/com_form2content/utils.form2content.php');
		
		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();		

		// Only activate on display of com_content article
		if ($app->isSite() && $doc->getType() == 'html' && $app->input->getWord('option') == 'com_content' && $app->input->getCmd('view') == 'article')
		{
			// Check if this is a F2C Article
			$db 	= JFactory::getDbo();
			$query 	= $db->getQuery(true);
			
			$query->select('frm.id, frm.title, frm.alias, frm.created, frm.modified, frm.publish_up, frm.publish_down, frm.reference_id');
			$query->select('frm.catid, frm.metakey, frm.metadesc, frm.created_by, frm.created_by_alias, frm.projectid, frm.language');
			$query->select('frm.extended, frm.featured, frm.modified_by');
			$query->from('#__f2c_form frm');
			$query->select('cat.title AS catTitle, cat.alias AS catAlias');
			$query->join('LEFT', '#__categories cat ON frm.catid = cat.id');
			$query->select('usr.name AS author, usr.username AS authorUsername, usr.email as authorEmail');
			$query->join('LEFT', '#__users usr ON frm.created_by = usr.id');
			$query->where('frm.reference_id = '.$app->input->getInt('id'));
			
			$db->setQuery($query);
			
			$form = $db->loadObject();
			
			if(!is_object($form))
			{
				return true;
			}
			
			$templateName	= 'metadata_injector_contenttype_' . $form->projectid . '.tpl';
			$templateFile 	= Path::Combine(F2cFactory::getConfig()->get('template_path'), $templateName);

			if($form->id && JFile::exists($templateFile))
			{ 
				// load the form and it's data
				JLoader::registerPrefix('F2c', JPATH_SITE.'/components/com_form2content/libraries/form2content');
				JLoader::register('Form2contentModelForm', JPATH_SITE.'/components/com_form2content/models/form.php');
								
				$query	= $db->getQuery(true);
				
				$query->select('fc.id AS fieldcontentid, frm.id as formid, fc.fieldid, fc.attribute, fc.content, pf.*, ft.name');				
				$query->from('#__f2c_form frm');
				$query->join('INNER', '#__f2c_projectfields pf on frm.projectid = pf.projectid');
				$query->join('INNER', '#__f2c_fieldtype ft on pf.fieldtypeid = ft.id');
				$query->join('LEFT', '#__f2c_fieldcontent fc on fc.fieldid = pf.id and fc.formid = frm.id');
				$query->where('frm.id = ' . $form->id);
				$query->order('pf.ordering, pf.fieldtypeid');
								
				$db->setQuery($query);
				
				$fieldContentList = $db->loadObjectList();
				
				$modelForm = new Form2contentModelForm();
				$fieldContentList = $modelForm->createFormDataObjects($fieldContentList);
				
				$form->fields = $fieldContentList[$form->id];
				
				// Handle the tags
				$form->tags = array();
				
				// Load item tags
              	$form->extended = new JRegistry($form->extended);
              	$tagList = $form->extended->get('tags');
                	
               	if(!empty($tagList))
               	{
					$form->tags = explode(',', $tagList);
               	} 		               	              							
				
               	$parser = new F2cParser();
               	
				if($parser->addTemplate($templateName, F2C_TEMPLATE_INTRO))
				{				
					$parser->addVars($form);
					$doc->addCustomTag($parser->parseIntro());
				}
			}
		}

		return true;		
	}
}
